/*                  30.9.2020
*                   TEDIA_EP4GXA ver. 3.15.01
*                   (c) 2020 TEDIA spol. s r. o.
*                   https://www.tedia.cz/podpora
*                   https://www.tedia.eu/support
*
*/


#ifndef __TEDIA_EP4GXA_H
#define __TEDIA_EP4GXA_H

#ifdef  __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef      BUILD_TEDIA_EP4GXA_DLL
    #define     EP4GXA_API      __declspec(dllexport) __stdcall
#else
    #define     EP4GXA_API      __declspec(dllimport) __stdcall
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////


#include <windows.h>


typedef       ULONG                           EP4GXA_RET;
        
        
#define       EP4GXA_Ok                       0x00000000
/* #define    EP4GXA_NotRunning               0x00000001 removed in >3.0 */
#define       EP4GXA_BadIndex                 0x00000002
#define       EP4GXA_AlreadyOpened            0x00000004
#define       EP4GXA_CardOpenErr              0x00000008
/* #define    EP4GXA_CardRegisterErr          0x00000010 removed in >3.0 */
#define       EP4GXA_IntEnableErr             0x00000020
#define       EP4GXA_NotOpened                0x00000040
#define       EP4GXA_BARErr                   0x00000080
#define       EP4GXA_IntDisabled              0x00000100
#define       EP4GXA_StopIntThread            0x00000200
#define       EP4GXA_NullPointer              0x00000400
#define       EP4GXA_CreateEvent              0x00000800
#define       EP4GXA_WaitTimeout              0x00001000
#define       EP4GXA_IntPending               0x00010000
#define       EP4GXA_OpenedSameProcess        0x00040000
#define       EP4GXA_InvalidAddress           0x40000000
#define       EP4GXA_VersionConflict          0x80000000



DWORD	    	EP4GXA_API	EP4GXA_InterfaceVersion(VOID);

EP4GXA_RET	EP4GXA_API	EP4GXA_DriverVersion(DWORD * ver);

EP4GXA_RET	EP4GXA_API	EP4GXA_CardsInSystem(DWORD * count);

EP4GXA_RET	EP4GXA_API	EP4GXA_Card_DID(DWORD inx, DWORD * did);

EP4GXA_RET	EP4GXA_API	EP4GXA_Card_BUS(DWORD inx, DWORD * bus);

EP4GXA_RET	EP4GXA_API	EP4GXA_Card_SLOT(DWORD inx, DWORD * slot);

EP4GXA_RET	EP4GXA_API	EP4GXA_Open(DWORD inx, BOOL enable_int);

EP4GXA_RET	EP4GXA_API	EP4GXA_OpenMulti(DWORD inx, BOOL enable_int);

EP4GXA_RET	EP4GXA_API	EP4GXA_Card_OpenCount(DWORD inx, DWORD *count);

EP4GXA_RET	EP4GXA_API	EP4GXA_Close(DWORD inx);

EP4GXA_RET	EP4GXA_API	EP4GXA_BAR0_BaseAdr(DWORD inx, size_t *base_adr, DWORD *range);

EP4GXA_RET	EP4GXA_API	EP4GXA_IRQ_Wait(DWORD inx, DWORD *);

DWORD	    	EP4GXA_API	EP4GXA_IRQ_Count(DWORD inx);

EP4GXA_RET	EP4GXA_API	EP4GXA_IRQ_SetTimeout(DWORD inx, DWORD timeout);

EP4GXA_RET	EP4GXA_API	EP4GXA_ReadReg8 (DWORD inx, DWORD offset, BYTE *data);

EP4GXA_RET	EP4GXA_API	EP4GXA_WriteReg8 (DWORD inx, DWORD offset, BYTE data);

EP4GXA_RET	EP4GXA_API	EP4GXA_ReadReg32 (DWORD inx, DWORD offset, DWORD *data);

EP4GXA_RET	EP4GXA_API	EP4GXA_WriteReg32 (DWORD inx, DWORD offset, DWORD data);


/////////////////////////////////////////////////////////////////////////////////////////////////


#ifdef __cplusplus
 }
#endif

#endif
