//______________________________________________________________________________
//
//                   TEDIA_EP4GXA.DLL library Delphi header file
//
//                                ver. 3.15.01
//
//                   (c) 2020 TEDIA spol. s r. o. (30.9.2020)
// 
//                         https://www.tedia.cz/podpora
//                         https://www.tedia.eu/support
//
//______________________________________________________________________________
//______________________________________________________________________________
//______________________________________________________________________________


unit tedia_ep4gxa;

interface
uses Windows;


//______________________________________________________________________________

const

// return codes (EP4GXA_RET)

  EP4GXA_Ok                 = $00000000;
  EP4GXA_BadIndex           = $00000002;
  EP4GXA_AlreadyOpened      = $00000004;
  EP4GXA_CardOpenErr        = $00000008;
  EP4GXA_IntEnableErr       = $00000020;
  EP4GXA_NotOpened          = $00000040;
  EP4GXA_BARErr             = $00000080;
  EP4GXA_IntDisabled        = $00000100;
  EP4GXA_StopIntThread      = $00000200;
  EP4GXA_NullPointer        = $00000400;
  EP4GXA_CreateEvent        = $00000800;
  EP4GXA_WaitTimeout        = $00001000;
  EP4GXA_IntPending         = $00010000;
  EP4GXA_OpenedSameProcess  = $00040000;
  EP4GXA_InvalidAddress     = $40000000;
  EP4GXA_VersionConflict    = $80000000;


type
  Bool       = cardinal;
  DWord      = cardinal;
  PDWord     = ^DWord;
  PByte      = ^Byte;
  EP4GXA_RET = DWord;



//_____________________________________________________________ list of functions


function EP4GXA_InterfaceVersion:DWord; stdcall;

function EP4GXA_DriverVersion(ver:PDWord):EP4GXA_RET; stdcall;

function EP4GXA_CardsInSystem(count:PDWord):EP4GXA_RET; stdcall;

function EP4GXA_Card_DID(inx:DWord; did:PDWord):EP4GXA_RET; stdcall;

function EP4GXA_Card_BUS(inx:DWord; bus:PDWord):EP4GXA_RET; stdcall;

function EP4GXA_Card_SLOT(inx:DWord; slot:PDWord):EP4GXA_RET; stdcall;

function EP4GXA_Open(inx:DWord; enable_int:Bool):EP4GXA_RET; stdcall;

function EP4GXA_OpenMulti(inx:DWord; enable_int:Bool):EP4GXA_RET; stdcall;

function EP4GXA_Card_OpenCount(inx:DWord; open_count:PDWord):EP4GXA_RET; stdcall;

function EP4GXA_Close(inx:DWord):EP4GXA_RET; stdcall;

function EP4GXA_BAR0_BaseAdr(inx:DWord; base_adr:PNativeUInt; range:PDWord):EP4GXA_RET; stdcall;

function EP4GXA_IRQ_Wait(inx:DWord; reserve:PDWord):EP4GXA_RET; stdcall;

function EP4GXA_IRQ_Count(inx:DWord):DWord; stdcall;

function EP4GXA_IRQ_SetTimeout(inx:DWord; timeout:DWord):EP4GXA_RET; stdcall;

function EP4GXA_ReadReg8(inx:DWord; offset:DWord; data:PByte):EP4GXA_RET; stdcall;

function EP4GXA_WriteReg8(inx:DWord; offset:DWord; data:Byte):EP4GXA_RET; stdcall;

function EP4GXA_ReadReg32(inx:DWord; offset:DWord; data:PDWord):EP4GXA_RET; stdcall;

function EP4GXA_WriteReg32(inx:DWord; offset:DWord; data:DWord):EP4GXA_RET; stdcall;



//________________________________________________________________ implementation

implementation

function EP4GXA_InterfaceVersion;       external 'tedia_ep4gxa.dll';
function EP4GXA_DriverVersion;          external 'tedia_ep4gxa.dll';
function EP4GXA_CardsInSystem;          external 'tedia_ep4gxa.dll';
function EP4GXA_Card_DID;               external 'tedia_ep4gxa.dll';
function EP4GXA_Card_BUS;               external 'tedia_ep4gxa.dll';
function EP4GXA_Card_SLOT;              external 'tedia_ep4gxa.dll';
function EP4GXA_Open;                   external 'tedia_ep4gxa.dll';
function EP4GXA_OpenMulti;              external 'tedia_ep4gxa.dll';
function EP4GXA_Card_OpenCount;         external 'tedia_ep4gxa.dll';
function EP4GXA_Close;                  external 'tedia_ep4gxa.dll';
function EP4GXA_BAR0_BaseAdr;           external 'tedia_ep4gxa.dll';
function EP4GXA_IRQ_Wait;               external 'tedia_ep4gxa.dll';
function EP4GXA_IRQ_Count;              external 'tedia_ep4gxa.dll';
function EP4GXA_IRQ_SetTimeout;         external 'tedia_ep4gxa.dll';
function EP4GXA_ReadReg8;               external 'tedia_ep4gxa.dll';
function EP4GXA_WriteReg8;              external 'tedia_ep4gxa.dll';
function EP4GXA_ReadReg32;              external 'tedia_ep4gxa.dll';
function EP4GXA_WriteReg32;             external 'tedia_ep4gxa.dll';

//______________________________________________________________________________

begin
end.
